/* Funcitons */

func foo() {
   print("Hello")
}

func getHello() -> String {
   return "Hello"
}

func greet(name:String) -> String {
   return "Hello, \(name)"
}

greet(name: "hey")


func addition( x:Int, y:Int) -> Int {
    var x = x  // make x a var
    x += 1
   return x + y
}

// Return multiple value
func getName() -> (first:String, last:String) {
   let f = "Bob"
   let l = "Smith"
   
   return (f, l)
}

let (first, last) = getName()
first
getName().0
getName().first











// Return Optional
func getAge() -> Int? {
   return 45
}
let a = getAge()
a!

// Retrun optional multiple value
func getName2() -> (first:String, last:String)? {
   let f = "Bob"
   let l = "Smith"
   
   return (f, l)
}
let x = getName2()
x!
















// External Parameter Names
func makeRect(length:Int, height:Int) {
   //..
}
makeRect(length: 23, height: 45)
// By default, all parameters except the first parameter have external names

func makeRect2(length len:Int, height heit:Int) {
   print("making a rect of \(len) and \(heit)")
   //..
}
makeRect2(length: 23, height: 45)


func makeRect3(length:Int, height:Int) {
   //..
}
makeRect3(length: 23, height: 45)

// Delete the default external name
func makeRect33(_ length:Int, _ height:Int) {
    //..
}
makeRect33(23, 45)







// Parameter with default value
func makeRect4(_ length:Int, height:Int = 10) {
   //..
}
makeRect4(23)
makeRect4(23, height:45)  // param with default value always has an external name, effectively like having #

func makeRect5(length:Int, _ height:Int = 10) { // no external name
   //..                                         // Not recommanded
}
















// Variadic Parameters
func sum(x:Int, numbers:Int...) -> Int {
   var total = 0
   for x in numbers {
      total = total + x
   }
   return total
}
sum(x: 1,numbers: 3,4,6,9)
// A function may have at most one variadic parameter, and it
// must appear last in the parameter list













// var parameters
func makeRect6(length:Int, height:Int) {
   //length = 56;  // parameters are constant by default
   var height = height;
   height = height + 1;  // height is a variable
}
var h = 10;
makeRect6(length: 2, height: h)
h  // changes are not visible outside of the function


// output parameter
func makeRect7(length:Int, height:inout Int) {
   height = height + 1;
}
var i = 10;
makeRect7(length: 2, height: &i)  // & is added
i  // changes are not visible outside of the function









/* Funcitonal Programming */

func add(a:Int, b:Int) ->Int {
   return a + b;
}

func multiply(a:Int, b:Int) ->Int {
   return a * b;
}

// Function as variable
var f1:(Int, Int)->Int

f1 = add
f1(3,4)

f1 = multiply
f1(3,4)















// Function as parameter
func arrayOp(f:(Int, Int)->Int, arr1:[Int], arr2:[Int]) -> [Int] {
   var ret = [Int]()
   for (i, _) in arr1.enumerated() {
      ret.append(f(arr1[i], arr2[i]))
   }
   return ret
}
arrayOp(f: add, arr1: [2,3,4], arr2: [4,5,6])
arrayOp(f: multiply, arr1: [2,3,4], arr2: [4,5,6])





// Function as return value
func getOp(flag:Int) -> (Int, Int)->Int { // return value has no ()
   if flag == 0 {
      return add
   } else {
      return multiply
   }
}


// Nested Funciton
func getOp2(flag:Int) -> (Int, Int)->Int {
   func add(a:Int, b:Int) ->Int {
      return a + b;
   }
   func multiply(a:Int, b:Int) ->Int {
      return a * b;
   }
   if flag == 0 {
      return add
   } else {
      return multiply
   }
}


// Array of functions
var arr:[(Int, Int)->Int] = []
arr.append(add)
arr.append(multiply)
for f in arr {
   // do something with the funcitons
}

// How to create a dictionary of funcitons?











